<!-- -*- sgml -*- -->
<!DOCTYPE spec PUBLIC "-//Ken MacLeod//DTD GSF Spec//EN">
<spec>
  <head></head>
  <rules>
    <rule> <query/SIMPLE/            <isa/Document/

    <!-- Header Elements -->
    <rule> <query/HEAD/              <isa/Holder/
      <rules>
	<rule> <query/TITLE/         <save/{title}/
	<rule> <query/AUTHOR/        <isa/Author/
	  <push/{authors}/
	  <rules>
	    <rule> <query/NAME/      <save/{formattedname}/
	    <rule> <query/EMAIL/     <save/{email}/
	  </rules>
	<rule> <query/ABSTRACT/      <save/{abstract}/
	<rule> <query/COPYRIGHT/     <save/{copyright}/
	<rule> <query/VERSION/       <save/{version}/
	<rule> <query/DATE/          <save/{date}/
      </rules>
    </rule>

    <!-- Body Elements -->
    <rule> <query/SECT/              <isa/Section/
    <rule> <query/TITLE/             <save/{title}/
    <rule> <query/PAR/               <isa/Paragraph/
    <rule> <query/UL/                <isa/List ('type' => 'itemized')/
    <rule> <query/OL/                <isa/List ('type' => 'ordered')/
    <rule> <query/DL/                <isa/List ('type' => 'variable')/
    <rule> <query/LT/                <isa/ListTerm/
    <rule> <query/LI/                <isa/ListItem/
    <rule> <query/EXAMPLE/           <isa/Screen/

    <!-- Inline Elements -->
    <rule> <query/FILENAME COMMANDNAME FUNCTION ENVVAR PARAMETER SAMPLE/
      <isa/Inline_Literal/
      <!-- XXX this should use a CDATAATTR element -->
    <rule> <query/URL/               <isa/URL ('url' => new_arr Text::GDO::SGML::Event ('cdata', <attr/URL/, undef, undef))/

    <rule> <query/PACKAGE STANDARD/  <isa/Inline/
    <rule> <query/EMPH/              <isa/Inline_Emphasis/
    <rule> <query/QUOTE/             <isa/Inline_Quote/

  </rules>

  <stuff>
sub save_attr {
    my ($self, $data, $event) = @_;
    my ($parent) = $data->{'diversion'}[-1];
    my ($id, $id_type, $id_attr);

    if ($id_attr = $event->data->attribute ('ID')) {
        $id_type = $id_attr->type;
        if ($id_type ne 'IMPLIED') {
            $id = $id_attr->value;
            $parent->{'id'} = $id;
            new Text::GDO::Reference ($data, 'object' => $parent, 'id' => $id);
        }
    }
}
</stuff>
</spec>
