# -*- perl -*-
#
# Copyright (C) 1996 Ken MacLeod
# See the file COPYING for distribution terms.
#

require "docbook-ascii.pl";
require "docbook-html.pl";

open (SGMLS, "| $Text::GDO::NSGMLS -s >check-out 2>&1")
    || die "$::prog: can't open pipe to \`$Text::GDO::NSGMLS', $!\n";
print SGMLS <<'EOTEST';
<!DOCTYPE book PUBLIC "-//Davenport//DTD DocBook V2.3//EN">
<book>
  <bookinfo>
    <bookbiblio>
      <authorgroup>
        <corpauthor>delete me</corpauthor>
      </authorgroup>
    </bookbiblio>
  </bookinfo>

  <chapter>
    <title>dummy chapter title</title>

    <sect1>
      <title>dummy section title</title>
      <para>dummy paragraph</para>
    </sect1>
  </chapter>
</book>
EOTEST
close (SGMLS);

if (-s "check-out") {
    warn "$::prog: error checking for DocBook V2.3 DTD, not installed?\n";
    $tests->{'docbook'}{'no-test'} = 1;
    return 1;
}

#
#
#
$tests->{'docbook'}{'source'}{"dummy"} = <<'EOTEST';
<!DOCTYPE book PUBLIC "-//Davenport//DTD DocBook V2.3//EN">
<book>
  <bookinfo>
    <bookbiblio>
      <authorgroup>
        <corpauthor>delete me</corpauthor>
      </authorgroup>
    </bookbiblio>
  </bookinfo>

  <chapter>
    <title>dummy chapter title</title>

    <sect1>
      <title>dummy section title</title>
      <para>dummy paragraph</para>
    </sect1>
  </chapter>
</book>
EOTEST

$tests->{'docbook'}{'source'}{"article-header"} = <<'EOTEST';
<!DOCTYPE article PUBLIC "-//HaL and O'Reilly//DTD DocBook//EN">
<article>
  <artheader>

    <title>DocBook Title</title>
    <subtitle>DocBook SubTitle</subtitle>

    <authorgroup>
      <author>
        <firstname>FirstName1</firstname>
        <surname>SurName1</surname>
        <affiliation>
          <orgname>OrgName1</orgname>
          <orgdiv>OrgDiv1</orgdiv>
          <address><email>email1@address</email></address>
        </affiliation>
      </author>
      <author>
        <firstname>FirstName2</firstname>
        <surname>SurName2</surname>
        <affiliation>
          <orgname>OrgName2</orgname>
          <orgdiv>OrgDiv2</orgdiv>
          <address><email>email2@address</email></address>
        </affiliation>
      </author>
    </authorgroup>
    <artpagenums>[not given]</artpagenums>
  </artheader>

  <sect1>
    <title>dummy section title</title>
    <para>dummy paragraph</para>
  </sect1>
</article>
EOTEST

#
# Copyright
#
$tests->{'docbook'}{'source'}{"copyright"} = <<'EOTEST';
<!DOCTYPE book PUBLIC "-//Davenport//DTD DocBook V2.3//EN">
<book>
  <bookinfo>
    <bookbiblio>
      <authorgroup>
        <corpauthor>dummy</corpauthor>
      </authorgroup>
      <copyright>
        <year>1992</year>
        <year>1993</year>
        <year>1994</year>
        <year>1995</year>
        <holder>OrgName1</holder>
        <holder>OrgName2</holder>
      </copyright>
    </bookbiblio>
  </bookinfo>

  <chapter>
    <title>dummy chapter title</title>

    <sect1>
      <title>dummy section title</title>
      <para>dummy paragraph</para>
    </sect1>
  </chapter>
</book>
EOTEST

#
#
#
$tests->{'docbook'}{'source'}{"xref"} = <<'EOTEST';
<!DOCTYPE chapter PUBLIC "-//Davenport//DTD DocBook V2.3//EN">
<chapter id="chapter1">
  <title>dummy chapter title</title>

  <sect1>
    <title>dummy section title</title>
    <para>Cross reference to chapter 1, <xref linkend="chapter1">.</para>
  </sect1>
</chapter>
EOTEST

1;
